_G[gTable] = {};

local aTmpVal   = gTable;
cm.SetupTable(_G[aTmpVal]);

-- Called on Init
_G[gTable].OnInit = function(pObj)
	pObj.mState = 0;
end


-- Called after data being loaded from disk
_G[gTable].OnLoad = function(pObj)

end


-- Called on a update
_G[gTable].OnUpdate = function(pObj)

end


-- Called on a succesful click
_G[gTable].OnClick =  function(pObj, pName, pActorObj, pPolyNum, pX, pY)

	pObj.mDiscovered = true;
	if pName == "" then
      cm.GetShowInfo(pObj, "InfoStr1", "InfoTime1");
   	return true;

	elseif pName == pObj.mCsData:GetString("KeyObject1")
      or pName == pObj.mCsData:GetString("KeyObject2")
      or pName == pObj.mCsData:GetString("KeyObject3")
   then

      pObj:StartFadeRects(PhFadeAnotherTimeShort);
		pObj.mState		 = pObj.mState   + 1;
		pObj.mCurCell   = pObj.mCurCell + 1;
		_G[pActorObj.mScriptTag].OnUse(pActorObj, pObj);

      if pObj.mState == 3 then
   		cm.DisableObject(pObj);
   		cm.SetGlobalValIndirect(pObj, "SetFlag1", true);
   		cm.GetShowInfo(pObj, "InfoStr2", "InfoTime2");
		end
		return true;

	else
		cm.ObjDoesNotWork(pObj);
		return false;
	end

   return false;
end



-- Called on draw
_G[gTable].OnDraw =  function(pObj, pG)

	local aRpos = pObj.mSmPos;
	local aImg  = IcImageWrap(pObj.mSmallImage);
	assert(aImg);
	local aRect = aImg:GetCelRect(pObj.mCurCell);
	pG:DrawImage(aImg:GetImage(), aRpos.x, aRpos.y, aRect);

end


